#include "skse64/NiRTTI.h"
#include "skse64/NiObjects.h"

NiObject * DoNiRTTICast(NiObject * src, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (src)
		for (NiRTTI * iter = src->GetRTTI(); iter; iter = iter->parent)
			if (iter == (NiRTTI *)typeAddr)
				return src;

	return nullptr;
}

bool IsType(NiRTTI * rtti, const NiRTTI * typeInfo)
{
	uintptr_t typeAddr = uintptr_t(typeInfo) + RelocationManager::s_baseAddr;
	if (rtti)
		return uintptr_t(rtti) == typeAddr;

	return false;
}

const NiRTTI *	NiRTTI_BGSDecalNode = (NiRTTI *)0x01F5DFA0;
const NiRTTI *	NiRTTI_BSAnimGroupSequence = (NiRTTI *)0x01F5E100;
const NiRTTI *	NiRTTI_BSSplatterExtraData = (NiRTTI *)0x02F5F150;
const NiRTTI *	NiRTTI_BGSAddonNodeSoundHandleExtra = (NiRTTI *)0x02F5F5B8;
const NiRTTI *	NiRTTI_REFRSyncController = (NiRTTI *)0x02F995D0;
const NiRTTI *	NiRTTI_bhkCartTether = (NiRTTI *)0x02F9AD38;
const NiRTTI *	NiRTTI_bhkTiltPreventAction = (NiRTTI *)0x02F9AD48;
const NiRTTI *	NiRTTI_bhkWheelAction = (NiRTTI *)0x02F9AD58;
const NiRTTI *	NiRTTI_BSFaceGenAnimationData = (NiRTTI *)0x02F9B398;
const NiRTTI *	NiRTTI_BSFaceGenModelExtraData = (NiRTTI *)0x02FA18C0;
const NiRTTI *	NiRTTI_BSFaceGenBaseMorphExtraData = (NiRTTI *)0x02FA18E8;
const NiRTTI *	NiRTTI_BSFaceGenMorphData = (NiRTTI *)0x02FA18F8;
const NiRTTI *	NiRTTI_BSFaceGenMorphDataHead = (NiRTTI *)0x02FA1908;
const NiRTTI *	NiRTTI_BSFaceGenMorphDataHair = (NiRTTI *)0x02FA1918;
const NiRTTI *	NiRTTI_BSFaceGenNiNode = (NiRTTI *)0x02FA1958;
const NiRTTI *	NiRTTI_BSTempEffect = (NiRTTI *)0x02FA6D28;
const NiRTTI *	NiRTTI_BSTempEffectDebris = (NiRTTI *)0x02FA6DA8;
const NiRTTI *	NiRTTI_BSTempEffectGeometryDecal = (NiRTTI *)0x02FA6DC8;
const NiRTTI *	NiRTTI_BSTempEffectParticle = (NiRTTI *)0x02FA6E78;
const NiRTTI *	NiRTTI_BSTempEffectSimpleDecal = (NiRTTI *)0x02FA6EA0;
const NiRTTI *	NiRTTI_BSTempEffectSPG = (NiRTTI *)0x02FA6EB8;
const NiRTTI *	NiRTTI_bhkAutoWater = (NiRTTI *)0x02FBE290;
const NiRTTI *	NiRTTI_ModelReferenceEffect = (NiRTTI *)0x02FBFE38;
const NiRTTI *	NiRTTI_ReferenceEffect = (NiRTTI *)0x02FBFE70;
const NiRTTI *	NiRTTI_ShaderReferenceEffect = (NiRTTI *)0x02FBFEA0;
const NiRTTI *	NiRTTI_SummonPlacementEffect = (NiRTTI *)0x02FBFED0;
const NiRTTI *	NiRTTI_SceneGraph = (NiRTTI *)0x02FD3968;
const NiRTTI *	NiRTTI_BSDoorHavokController = (NiRTTI *)0x02FD5688;
const NiRTTI *	NiRTTI_BSPlayerDistanceCheckController = (NiRTTI *)0x02FD5698;
const NiRTTI *	NiRTTI_BSSimpleScaleController = (NiRTTI *)0x02FD56A8;
const NiRTTI *	NiRTTI_NiObject = (NiRTTI *)0x030AD230;
const NiRTTI *	NiRTTI_NiAVObject = (NiRTTI *)0x030AD268;
const NiRTTI *	NiRTTI_NiNode = (NiRTTI *)0x030AD288;
const NiRTTI *	NiRTTI_NiObjectNET = (NiRTTI *)0x030AD408;
const NiRTTI *	NiRTTI_NiLight = (NiRTTI *)0x030AD460;
const NiRTTI *	NiRTTI_NiSwitchNode = (NiRTTI *)0x030AD470;
const NiRTTI *	NiRTTI_NiStringsExtraData = (NiRTTI *)0x030AD480;
const NiRTTI *	NiRTTI_NiCamera = (NiRTTI *)0x030AD490;
const NiRTTI *	NiRTTI_BSTriShape = (NiRTTI *)0x030AD4A8;
const NiRTTI *	NiRTTI_NiProperty = (NiRTTI *)0x030AD4B8;
const NiRTTI *	NiRTTI_NiAlphaProperty = (NiRTTI *)0x030AD4D0;
const NiRTTI *	NiRTTI_NiSourceTexture = (NiRTTI *)0x030AE508;
const NiRTTI *	NiRTTI_BSFlattenedBoneTree = (NiRTTI *)0x030AE518;
const NiRTTI *	NiRTTI_BSDismemberSkinInstance = (NiRTTI *)0x030AE560;
const NiRTTI *	NiRTTI_NiStringExtraData = (NiRTTI *)0x030AE570;
const NiRTTI *	NiRTTI_NiTimeController = (NiRTTI *)0x030AE580;
const NiRTTI *	NiRTTI_NiExtraData = (NiRTTI *)0x030AE5A0;
const NiRTTI *	NiRTTI_NiGeometryData = (NiRTTI *)0x030AE5B0;
const NiRTTI *	NiRTTI_BSGeometry = (NiRTTI *)0x030AE5C8;
const NiRTTI *	NiRTTI_BSDynamicTriShape = (NiRTTI *)0x030AE5E0;
const NiRTTI *	NiRTTI_NiPointLight = (NiRTTI *)0x030AE5F0;
const NiRTTI *	NiRTTI_NiDefaultAVObjectPalette = (NiRTTI *)0x030AE600;
const NiRTTI *	NiRTTI_NiBillboardNode = (NiRTTI *)0x030AE628;
const NiRTTI *	NiRTTI_NiDirectionalLight = (NiRTTI *)0x030AE638;
const NiRTTI *	NiRTTI_NiCullingProcess = (NiRTTI *)0x030AE648;
const NiRTTI *	NiRTTI_NiParticles = (NiRTTI *)0x030AE660;
const NiRTTI *	NiRTTI_NiTexture = (NiRTTI *)0x030AE6A0;
const NiRTTI *	NiRTTI_NiSkinPartition = (NiRTTI *)0x030AE7B0;
const NiRTTI *	NiRTTI_NiVertWeightsExtraData = (NiRTTI *)0x030AE7C0;
const NiRTTI *	NiRTTI_NiSkinInstance = (NiRTTI *)0x030AE7D0;
const NiRTTI *	NiRTTI_NiAVObjectPalette = (NiRTTI *)0x030AE7E0;
const NiRTTI *	NiRTTI_NiGeometry = (NiRTTI *)0x030AE7F0;
const NiRTTI *	NiRTTI_NiSkinData = (NiRTTI *)0x030AE820;
const NiRTTI *	NiRTTI_NiShadeProperty = (NiRTTI *)0x030AE830;
const NiRTTI *	NiRTTI_NiAlphaAccumulator = (NiRTTI *)0x030AE848;
const NiRTTI *	NiRTTI_NiAmbientLight = (NiRTTI *)0x030AE858;
const NiRTTI *	NiRTTI_NiBinaryExtraData = (NiRTTI *)0x030AE868;
const NiRTTI *	NiRTTI_NiBooleanExtraData = (NiRTTI *)0x030AE878;
const NiRTTI *	NiRTTI_NiBSPNode = (NiRTTI *)0x030AE888;
const NiRTTI *	NiRTTI_NiColorExtraData = (NiRTTI *)0x030AE898;
const NiRTTI *	NiRTTI_NiFloatExtraData = (NiRTTI *)0x030AE8A8;
const NiRTTI *	NiRTTI_NiFloatsExtraData = (NiRTTI *)0x030AE8B8;
const NiRTTI *	NiRTTI_NiFogProperty = (NiRTTI *)0x030AE8C8;
const NiRTTI *	NiRTTI_NiIntegerExtraData = (NiRTTI *)0x030AE8E0;
const NiRTTI *	NiRTTI_NiIntegersExtraData = (NiRTTI *)0x030AE8F0;
const NiRTTI *	NiRTTI_NiParticlesData = (NiRTTI *)0x030AE938;
const NiRTTI *	NiRTTI_NiParticleMeshesData = (NiRTTI *)0x030AE948;
const NiRTTI *	NiRTTI_NiParticleMeshes = (NiRTTI *)0x030AE958;
const NiRTTI *	NiRTTI_NiSpotLight = (NiRTTI *)0x030AE968;
const NiRTTI *	NiRTTI_NiSwitchStringExtraData = (NiRTTI *)0x030AE978;
const NiRTTI *	NiRTTI_NiTriShapeData = (NiRTTI *)0x030AE988;
const NiRTTI *	NiRTTI_NiTriShape = (NiRTTI *)0x030AE998;
const NiRTTI *	NiRTTI_NiTriStripsData = (NiRTTI *)0x030AE9A8;
const NiRTTI *	NiRTTI_NiTriStrips = (NiRTTI *)0x030AE9B8;
const NiRTTI *	NiRTTI_NiVectorExtraData = (NiRTTI *)0x030AE9C8;
const NiRTTI *	NiRTTI_BSLODTriShape = (NiRTTI *)0x030AE9F0;
const NiRTTI *	NiRTTI_NiAdditionalGeometryData = (NiRTTI *)0x030AEA00;
const NiRTTI *	NiRTTI_BSSegmentedTriShape = (NiRTTI *)0x030AEA18;
const NiRTTI *	NiRTTI_NiBackToFrontAccumulator = (NiRTTI *)0x030AEA50;
const NiRTTI *	NiRTTI_NiAccumulator = (NiRTTI *)0x030AEA60;
const NiRTTI *	NiRTTI_NiTriBasedGeomData = (NiRTTI *)0x030AEA70;
const NiRTTI *	NiRTTI_NiTriBasedGeom = (NiRTTI *)0x030AEA80;
const NiRTTI *	NiRTTI_NiCollisionData = (NiRTTI *)0x030AEAC0;
const NiRTTI *	NiRTTI_NiControllerManager = (NiRTTI *)0x030AEB58;
const NiRTTI *	NiRTTI_NiControllerSequence = (NiRTTI *)0x030AEB78;
const NiRTTI *	NiRTTI_NiBlendInterpolator = (NiRTTI *)0x030AEBA8;
const NiRTTI *	NiRTTI_NiMultiTargetTransformController = (NiRTTI *)0x030AEBB8;
const NiRTTI *	NiRTTI_BSMultiTargetTreadTransfController = (NiRTTI *)0x030AEBC8;
const NiRTTI *	NiRTTI_NiInterpController = (NiRTTI *)0x030AEBD8;
const NiRTTI *	NiRTTI_NiFloatData = (NiRTTI *)0x030AF9A8;
const NiRTTI *	NiRTTI_NiFloatInterpolator = (NiRTTI *)0x030AF9B8;
const NiRTTI *	NiRTTI_NiColorData = (NiRTTI *)0x030AF9C8;
const NiRTTI *	NiRTTI_NiColorInterpolator = (NiRTTI *)0x030AF9D8;
const NiRTTI *	NiRTTI_NiSingleInterpController = (NiRTTI *)0x030AF9E8;
const NiRTTI *	NiRTTI_NiTransformInterpolator = (NiRTTI *)0x030AF9F8;
const NiRTTI *	NiRTTI_NiPathInterpolator = (NiRTTI *)0x030AFA08;
const NiRTTI *	NiRTTI_NiBlendTransformInterpolator = (NiRTTI *)0x030AFA28;
const NiRTTI *	NiRTTI_NiBlendFloatInterpolator = (NiRTTI *)0x030AFA38;
const NiRTTI *	NiRTTI_NiFloatExtraDataController = (NiRTTI *)0x030AFA48;
const NiRTTI *	NiRTTI_NiTransformController = (NiRTTI *)0x030AFA58;
const NiRTTI *	NiRTTI_NiBlendAccumTransformInterpolator = (NiRTTI *)0x030AFA68;
const NiRTTI *	NiRTTI_NiInterpolator = (NiRTTI *)0x030AFA80;
const NiRTTI *	NiRTTI_BSBlendTreadTransfInterpolator = (NiRTTI *)0x030AFAA0;
const NiRTTI *	NiRTTI_NiKeyBasedInterpolator = (NiRTTI *)0x030AFAB8;
const NiRTTI *	NiRTTI_NiTransformData = (NiRTTI *)0x030AFB38;
const NiRTTI *	NiRTTI_NiPosData = (NiRTTI *)0x030AFB48;
const NiRTTI *	NiRTTI_NiBlendBoolInterpolator = (NiRTTI *)0x030AFB58;
const NiRTTI *	NiRTTI_NiBlendColorInterpolator = (NiRTTI *)0x030AFB68;
const NiRTTI *	NiRTTI_NiBlendPoint3Interpolator = (NiRTTI *)0x030AFB78;
const NiRTTI *	NiRTTI_NiBlendQuaternionInterpolator = (NiRTTI *)0x030AFB88;
const NiRTTI *	NiRTTI_NiBoolData = (NiRTTI *)0x030AFB98;
const NiRTTI *	NiRTTI_NiBoolInterpolator = (NiRTTI *)0x030AFBA8;
const NiRTTI *	NiRTTI_NiBoolTimelineInterpolator = (NiRTTI *)0x030AFBB8;
const NiRTTI *	NiRTTI_NiBSplineBasisData = (NiRTTI *)0x030AFBC8;
const NiRTTI *	NiRTTI_NiBSplineData = (NiRTTI *)0x030AFBD8;
const NiRTTI *	NiRTTI_NiBSplineColorInterpolator = (NiRTTI *)0x030AFBE8;
const NiRTTI *	NiRTTI_NiBSplineCompColorInterpolator = (NiRTTI *)0x030AFBF8;
const NiRTTI *	NiRTTI_NiBSplineCompFloatInterpolator = (NiRTTI *)0x030AFC08;
const NiRTTI *	NiRTTI_NiBSplineCompPoint3Interpolator = (NiRTTI *)0x030AFC18;
const NiRTTI *	NiRTTI_NiBSplineCompTransformInterpolator = (NiRTTI *)0x030AFC28;
const NiRTTI *	NiRTTI_NiBSplineFloatInterpolator = (NiRTTI *)0x030AFC38;
const NiRTTI *	NiRTTI_NiBSplinePoint3Interpolator = (NiRTTI *)0x030AFC48;
const NiRTTI *	NiRTTI_NiBSplineTransformInterpolator = (NiRTTI *)0x030AFC58;
const NiRTTI *	NiRTTI_NiColorExtraDataController = (NiRTTI *)0x030AFC68;
const NiRTTI *	NiRTTI_NiFloatsExtraDataController = (NiRTTI *)0x030AFC78;
const NiRTTI *	NiRTTI_NiFloatsExtraDataPoint3Controller = (NiRTTI *)0x030AFC88;
const NiRTTI *	NiRTTI_NiKeyframeManager = (NiRTTI *)0x030AFCA0;
const NiRTTI *	NiRTTI_NiLightColorController = (NiRTTI *)0x030AFCB0;
const NiRTTI *	NiRTTI_NiLightDimmerController = (NiRTTI *)0x030AFCC0;
const NiRTTI *	NiRTTI_NiLookAtController = (NiRTTI *)0x030AFCD0;
const NiRTTI *	NiRTTI_NiLookAtInterpolator = (NiRTTI *)0x030AFCE0;
const NiRTTI *	NiRTTI_NiMorphData = (NiRTTI *)0x030AFCF0;
const NiRTTI *	NiRTTI_NiPathController = (NiRTTI *)0x030AFD00;
const NiRTTI *	NiRTTI_NiPoint3Interpolator = (NiRTTI *)0x030AFD10;
const NiRTTI *	NiRTTI_NiQuaternionInterpolator = (NiRTTI *)0x030AFD20;
const NiRTTI *	NiRTTI_NiRollController = (NiRTTI *)0x030AFD30;
const NiRTTI *	NiRTTI_NiRotData = (NiRTTI *)0x030AFD40;
const NiRTTI *	NiRTTI_NiSequence = (NiRTTI *)0x030AFD50;
const NiRTTI *	NiRTTI_NiSequenceStreamHelper = (NiRTTI *)0x030AFD70;
const NiRTTI *	NiRTTI_NiStringPalette = (NiRTTI *)0x030AFD80;
const NiRTTI *	NiRTTI_NiTextKeyExtraData = (NiRTTI *)0x030AFD90;
const NiRTTI *	NiRTTI_NiUVData = (NiRTTI *)0x030AFDA0;
const NiRTTI *	NiRTTI_NiVisController = (NiRTTI *)0x030AFDB0;
const NiRTTI *	NiRTTI_BSAnimNote = (NiRTTI *)0x030AFDC0;
const NiRTTI *	NiRTTI_BSAnimNotes = (NiRTTI *)0x030AFDD0;
const NiRTTI *	NiRTTI_BSGrabIKNote = (NiRTTI *)0x030AFDE0;
const NiRTTI *	NiRTTI_BSLookIKNote = (NiRTTI *)0x030AFDF0;
const NiRTTI *	NiRTTI_BSRotAccumTransfInterpolator = (NiRTTI *)0x030AFE00;
const NiRTTI *	NiRTTI_BSTreadTransfInterpolator = (NiRTTI *)0x030AFE10;
const NiRTTI *	NiRTTI_BSFrustumFOVController = (NiRTTI *)0x030AFE20;
const NiRTTI *	NiRTTI_NiExtraDataController = (NiRTTI *)0x030AFEB8;
const NiRTTI *	NiRTTI_NiBSplineInterpolator = (NiRTTI *)0x030AFEC8;
const NiRTTI *	NiRTTI_NiPoint3InterpController = (NiRTTI *)0x030AFED8;
const NiRTTI *	NiRTTI_NiFloatInterpController = (NiRTTI *)0x030AFEE8;
const NiRTTI *	NiRTTI_NiFloatController = (NiRTTI *)0x030AFEF8;
const NiRTTI *	NiRTTI_NiBoolInterpController = (NiRTTI *)0x030AFF08;
const NiRTTI *	NiRTTI_NiParticleSystem = (NiRTTI *)0x030AFF20;
const NiRTTI *	NiRTTI_NiPSysEmitterCtlr = (NiRTTI *)0x030AFF30;
const NiRTTI *	NiRTTI_NiPSysGravityModifier = (NiRTTI *)0x030AFF40;
const NiRTTI *	NiRTTI_BSPSysHavokUpdateModifier = (NiRTTI *)0x030AFF50;
const NiRTTI *	NiRTTI_NiMeshParticleSystem = (NiRTTI *)0x030AFF68;
const NiRTTI *	NiRTTI_NiPSysCylinderEmitter = (NiRTTI *)0x030AFF80;
const NiRTTI *	NiRTTI_BSStripParticleSystem = (NiRTTI *)0x030AFF90;
const NiRTTI *	NiRTTI_NiPSysEmitter = (NiRTTI *)0x030AFFA0;
const NiRTTI *	NiRTTI_NiPSysModifierCtlr = (NiRTTI *)0x030AFFB0;
const NiRTTI *	NiRTTI_NiPSysModifier = (NiRTTI *)0x030AFFC8;
const NiRTTI *	NiRTTI_NiPSysMeshUpdateModifier = (NiRTTI *)0x030AFFD8;
const NiRTTI *	NiRTTI_NiPSysUpdateCtlr = (NiRTTI *)0x030AFFE8;
const NiRTTI *	NiRTTI_NiMeshPSysData = (NiRTTI *)0x030AFFF8;
const NiRTTI *	NiRTTI_NiPSysAirFieldAirFrictionCtlr = (NiRTTI *)0x030B0008;
const NiRTTI *	NiRTTI_NiPSysAirFieldInheritVelocityCtlr = (NiRTTI *)0x030B0018;
const NiRTTI *	NiRTTI_NiPSysAirFieldModifier = (NiRTTI *)0x030B0028;
const NiRTTI *	NiRTTI_NiPSysAirFieldSpreadCtlr = (NiRTTI *)0x030B0038;
const NiRTTI *	NiRTTI_NiPSysAgeDeathModifier = (NiRTTI *)0x030B0048;
const NiRTTI *	NiRTTI_NiPSysBombModifier = (NiRTTI *)0x030B0058;
const NiRTTI *	NiRTTI_NiPSysBoundUpdateModifier = (NiRTTI *)0x030B0068;
const NiRTTI *	NiRTTI_NiPSysBoxEmitter = (NiRTTI *)0x030B0078;
const NiRTTI *	NiRTTI_NiPSysColliderManager = (NiRTTI *)0x030B0088;
const NiRTTI *	NiRTTI_NiPSysColorModifier = (NiRTTI *)0x030B0098;
const NiRTTI *	NiRTTI_NiPSysData = (NiRTTI *)0x030B00A8;
const NiRTTI *	NiRTTI_NiPSysDragFieldModifier = (NiRTTI *)0x030B00B8;
const NiRTTI *	NiRTTI_NiPSysDragModifier = (NiRTTI *)0x030B00C8;
const NiRTTI *	NiRTTI_NiPSysEmitterCtlrData = (NiRTTI *)0x030B00D8;
const NiRTTI *	NiRTTI_NiPSysEmitterDeclinationCtlr = (NiRTTI *)0x030B00E8;
const NiRTTI *	NiRTTI_NiPSysEmitterDeclinationVarCtlr = (NiRTTI *)0x030B00F8;
const NiRTTI *	NiRTTI_NiPSysEmitterInitialRadiusCtlr = (NiRTTI *)0x030B0108;
const NiRTTI *	NiRTTI_NiPSysEmitterLifeSpanCtlr = (NiRTTI *)0x030B0118;
const NiRTTI *	NiRTTI_NiPSysEmitterPlanarAngleCtlr = (NiRTTI *)0x030B0128;
const NiRTTI *	NiRTTI_NiPSysEmitterPlanarAngleVarCtlr = (NiRTTI *)0x030B0138;
const NiRTTI *	NiRTTI_NiPSysEmitterSpeedCtlr = (NiRTTI *)0x030B0148;
const NiRTTI *	NiRTTI_NiPSysFieldAttenuationCtlr = (NiRTTI *)0x030B0158;
const NiRTTI *	NiRTTI_NiPSysFieldMagnitudeCtlr = (NiRTTI *)0x030B0168;
const NiRTTI *	NiRTTI_NiPSysFieldMaxDistanceCtlr = (NiRTTI *)0x030B0178;
const NiRTTI *	NiRTTI_NiPSysGravityFieldModifier = (NiRTTI *)0x030B0188;
const NiRTTI *	NiRTTI_NiPSysGravityStrengthCtlr = (NiRTTI *)0x030B0198;
const NiRTTI *	NiRTTI_NiPSysGrowFadeModifier = (NiRTTI *)0x030B01A8;
const NiRTTI *	NiRTTI_NiPSysInitialRotAngleCtlr = (NiRTTI *)0x030B01B8;
const NiRTTI *	NiRTTI_NiPSysInitialRotAngleVarCtlr = (NiRTTI *)0x030B01C8;
const NiRTTI *	NiRTTI_NiPSysInitialRotSpeedCtlr = (NiRTTI *)0x030B01D8;
const NiRTTI *	NiRTTI_NiPSysInitialRotSpeedVarCtlr = (NiRTTI *)0x030B01E8;
const NiRTTI *	NiRTTI_NiPSysMeshEmitter = (NiRTTI *)0x030B01F8;
const NiRTTI *	NiRTTI_NiPSysModifierActiveCtlr = (NiRTTI *)0x030B0228;
const NiRTTI *	NiRTTI_NiPSysPlanarCollider = (NiRTTI *)0x030B0238;
const NiRTTI *	NiRTTI_NiPSysPositionModifier = (NiRTTI *)0x030B0248;
const NiRTTI *	NiRTTI_NiPSysRadialFieldModifier = (NiRTTI *)0x030B0258;
const NiRTTI *	NiRTTI_NiPSysResetOnLoopCtlr = (NiRTTI *)0x030B0268;
const NiRTTI *	NiRTTI_NiPSysRotationModifier = (NiRTTI *)0x030B0278;
const NiRTTI *	NiRTTI_NiPSysSpawnModifier = (NiRTTI *)0x030B0288;
const NiRTTI *	NiRTTI_NiPSysSphereEmitter = (NiRTTI *)0x030B0298;
const NiRTTI *	NiRTTI_NiPSysSphericalCollider = (NiRTTI *)0x030B02A8;
const NiRTTI *	NiRTTI_NiPSysTurbulenceFieldModifier = (NiRTTI *)0x030B02B8;
const NiRTTI *	NiRTTI_NiPSysVortexFieldModifier = (NiRTTI *)0x030B02C8;
const NiRTTI *	NiRTTI_BSStripPSysData = (NiRTTI *)0x030B02D8;
const NiRTTI *	NiRTTI_BSPSysRecycleBoundModifier = (NiRTTI *)0x030B02F0;
const NiRTTI *	NiRTTI_BSPSysInheritVelocityModifier = (NiRTTI *)0x030B0300;
const NiRTTI *	NiRTTI_NiPSysVolumeEmitter = (NiRTTI *)0x030B0310;
const NiRTTI *	NiRTTI_NiPSysModifierFloatCtlr = (NiRTTI *)0x030B0320;
const NiRTTI *	NiRTTI_NiPSysFieldModifier = (NiRTTI *)0x030B0330;
const NiRTTI *	NiRTTI_NiPSysModifierBoolCtlr = (NiRTTI *)0x030B0340;
const NiRTTI *	NiRTTI_NiPSysCollider = (NiRTTI *)0x030B0350;
const NiRTTI *	NiRTTI_BSMultiBound = (NiRTTI *)0x030B8608;
const NiRTTI *	NiRTTI_BSMultiBoundRoom = (NiRTTI *)0x030B8618;
const NiRTTI *	NiRTTI_BSMultiBoundAABB = (NiRTTI *)0x030B8630;
const NiRTTI *	NiRTTI_BSMultiBoundOBB = (NiRTTI *)0x030B8648;
const NiRTTI *	NiRTTI_BSXFlags = (NiRTTI *)0x030B8668;
const NiRTTI *	NiRTTI_BSValueNode = (NiRTTI *)0x030B8680;
const NiRTTI *	NiRTTI_BSWindModifier = (NiRTTI *)0x030BEC00;
const NiRTTI *	NiRTTI_BSTempNodeManager = (NiRTTI *)0x030BEC20;
const NiRTTI *	NiRTTI_BSTempNode = (NiRTTI *)0x030BEC30;
const NiRTTI *	NiRTTI_BSOcclusionShape = (NiRTTI *)0x030BEC50;
const NiRTTI *	NiRTTI_BSRangeNode = (NiRTTI *)0x030BED48;
const NiRTTI *	NiRTTI_BSBlastNode = (NiRTTI *)0x030BEF80;
const NiRTTI *	NiRTTI_BSDebrisNode = (NiRTTI *)0x030BEF90;
const NiRTTI *	NiRTTI_BSDamageStage = (NiRTTI *)0x030BEFA0;
const NiRTTI *	NiRTTI_BSPSysArrayEmitter = (NiRTTI *)0x030BEFB0;
const NiRTTI *	NiRTTI_PArrayPoint = (NiRTTI *)0x030BEFC0;
const NiRTTI *	NiRTTI_BSMultiStreamInstanceTriShape = (NiRTTI *)0x030BEFE8;
const NiRTTI *	NiRTTI_BSMultiBoundShape = (NiRTTI *)0x030BF018;
const NiRTTI *	NiRTTI_BSMultiBoundSphere = (NiRTTI *)0x030BF028;
const NiRTTI *	NiRTTI_BSOcclusionBox = (NiRTTI *)0x030BF040;
const NiRTTI *	NiRTTI_BSOcclusionPlane = (NiRTTI *)0x030BF058;
const NiRTTI *	NiRTTI_BSPortal = (NiRTTI *)0x030BF068;
const NiRTTI *	NiRTTI_BSPortalSharedNode = (NiRTTI *)0x030BF078;
const NiRTTI *	NiRTTI_BSBodyMorphOffsetsExtraData = (NiRTTI *)0x030BF090;
const NiRTTI *	NiRTTI_BSBehaviorGraphExtraData = (NiRTTI *)0x030BF0A0;
const NiRTTI *	NiRTTI_NiBSBoneLODController = (NiRTTI *)0x030BF0B8;
const NiRTTI *	NiRTTI_BSCullingProcess = (NiRTTI *)0x030BF0D8;
const NiRTTI *	NiRTTI_BSParticleSystemManager = (NiRTTI *)0x030BF0F8;
const NiRTTI *	NiRTTI_BSFurnitureMarkerNode = (NiRTTI *)0x030BF120;
const NiRTTI *	NiRTTI_BSBound = (NiRTTI *)0x030BF1A0;
const NiRTTI *	NiRTTI_BSMultiBoundNode = (NiRTTI *)0x030BF1C0;
const NiRTTI *	NiRTTI_BSBoneMap = (NiRTTI *)0x030BF1D0;
const NiRTTI *	NiRTTI_BSAnimInteractionMarker = (NiRTTI *)0x030BF1E8;
const NiRTTI *	NiRTTI_BSSceneGraph = (NiRTTI *)0x030BF200;
const NiRTTI *	NiRTTI_BSPSysMultiTargetEmitterCtlr = (NiRTTI *)0x030BF218;
const NiRTTI *	NiRTTI_BSGeometryListCullingProcess = (NiRTTI *)0x030BF230;
const NiRTTI *	NiRTTI_BSSubIndexTriShape = (NiRTTI *)0x030BF248;
const NiRTTI *	NiRTTI_BSDistantObjectLargeRefExtraData = (NiRTTI *)0x030BF258;
const NiRTTI *	NiRTTI_BSMasterParticleSystem = (NiRTTI *)0x030C0C20;
const NiRTTI *	NiRTTI_BSProceduralLightningController = (NiRTTI *)0x030C0C48;
const NiRTTI *	NiRTTI_BSInvMarker = (NiRTTI *)0x030C0C58;
const NiRTTI *	NiRTTI_BSBoneLODExtraData = (NiRTTI *)0x030C0C70;
const NiRTTI *	NiRTTI_BSReference = (NiRTTI *)0x030C0C90;
const NiRTTI *	NiRTTI_BSNodeReferences = (NiRTTI *)0x030C0CA0;
const NiRTTI *	NiRTTI_BSDecalPlacementVectorExtraData = (NiRTTI *)0x030C0CB0;
const NiRTTI *	NiRTTI_BSParentVelocityModifier = (NiRTTI *)0x030C0CC0;
const NiRTTI *	NiRTTI_BSWArray = (NiRTTI *)0x030C0CD0;
const NiRTTI *	NiRTTI_BSMultiBoundCapsule = (NiRTTI *)0x030C0CE8;
const NiRTTI *	NiRTTI_BSPSysStripUpdateModifier = (NiRTTI *)0x030C0CF8;
const NiRTTI *	NiRTTI_BSPSysSubTexModifier = (NiRTTI *)0x030C0D08;
const NiRTTI *	NiRTTI_BSPSysScaleModifier = (NiRTTI *)0x030C0D18;
const NiRTTI *	NiRTTI_BSLagBoneController = (NiRTTI *)0x030C0D28;
const NiRTTI *	NiRTTI_BSNonUniformScaleExtraData = (NiRTTI *)0x030C0D38;
const NiRTTI *	NiRTTI_BSNiNode = (NiRTTI *)0x030C0D50;
const NiRTTI *	NiRTTI_BSInstanceTriShape = (NiRTTI *)0x030C0D60;
const NiRTTI *	NiRTTI_bhkWorldObject = (NiRTTI *)0x030C7258;
const NiRTTI *	NiRTTI_bhkWorld = (NiRTTI *)0x030C7298;
const NiRTTI *	NiRTTI_bhkRigidBody = (NiRTTI *)0x030C83D8;
const NiRTTI *	NiRTTI_bhkCollisionObject = (NiRTTI *)0x030C83F0;
const NiRTTI *	NiRTTI_bhkNiCollisionObject = (NiRTTI *)0x030C84A0;
const NiRTTI *	NiRTTI_bhkAttachmentCollisionObject = (NiRTTI *)0x030C8520;
const NiRTTI *	NiRTTI_WeaponObject = (NiRTTI *)0x030C8530;
const NiRTTI *	NiRTTI_bhkRigidBodyT = (NiRTTI *)0x030C8558;
const NiRTTI *	NiRTTI_bhkWorldM = (NiRTTI *)0x030C8568;
const NiRTTI *	NiRTTI_bhkRefObject = (NiRTTI *)0x030C8590;
const NiRTTI *	NiRTTI_bhkSerializable = (NiRTTI *)0x030C85A0;
const NiRTTI *	NiRTTI_bhkShape = (NiRTTI *)0x030C85D0;
const NiRTTI *	NiRTTI_bhkEntity = (NiRTTI *)0x030C85E8;
const NiRTTI *	NiRTTI_bhkPhantom = (NiRTTI *)0x030C8600;
const NiRTTI *	NiRTTI_bhkAabbPhantom = (NiRTTI *)0x030C8618;
const NiRTTI *	NiRTTI_bhkSphereRepShape = (NiRTTI *)0x030C8630;
const NiRTTI *	NiRTTI_bhkConvexShape = (NiRTTI *)0x030C8648;
const NiRTTI *	NiRTTI_bhkPCollisionObject = (NiRTTI *)0x030C8658;
const NiRTTI *	NiRTTI_hkPackedNiTriStripsData = (NiRTTI *)0x030C8668;
const NiRTTI *	NiRTTI_bhkShapePhantom = (NiRTTI *)0x030C8680;
const NiRTTI *	NiRTTI_bhkSimpleShapePhantom = (NiRTTI *)0x030C8698;
const NiRTTI *	NiRTTI_bhkCapsuleShape = (NiRTTI *)0x030C86B0;
const NiRTTI *	NiRTTI_bhkBoxShape = (NiRTTI *)0x030C86C8;
const NiRTTI *	NiRTTI_bhkSphereShape = (NiRTTI *)0x030C86E0;
const NiRTTI *	NiRTTI_bhkBvTreeShape = (NiRTTI *)0x030C86F8;
const NiRTTI *	NiRTTI_bhkNiTriStripsShape = (NiRTTI *)0x030C8710;
const NiRTTI *	NiRTTI_bhkPackedNiTriStripsShape = (NiRTTI *)0x030C8738;
const NiRTTI *	NiRTTI_bhkBlendCollisionObject = (NiRTTI *)0x030C8750;
const NiRTTI *	NiRTTI_bhkAvoidBox = (NiRTTI *)0x030C8770;
const NiRTTI *	NiRTTI_bhkLimitedHingeConstraint = (NiRTTI *)0x030C8788;
const NiRTTI *	NiRTTI_bhkMalleableConstraint = (NiRTTI *)0x030C87A0;
const NiRTTI *	NiRTTI_bhkUnaryAction = (NiRTTI *)0x030C87B8;
const NiRTTI *	NiRTTI_bhkConstraint = (NiRTTI *)0x030C87D0;
const NiRTTI *	NiRTTI_bhkPrismaticConstraint = (NiRTTI *)0x030C87E8;
const NiRTTI *	NiRTTI_bhkAction = (NiRTTI *)0x030C8800;
const NiRTTI *	NiRTTI_bhkTriSampledHeightFieldBvTreeShape = (NiRTTI *)0x030C8818;
const NiRTTI *	NiRTTI_bhkCachingShapePhantom = (NiRTTI *)0x030C9488;
const NiRTTI *	NiRTTI_bhkRagdollTemplateData = (NiRTTI *)0x030C94B0;
const NiRTTI *	NiRTTI_bhkRagdollTemplate = (NiRTTI *)0x030C94C0;
const NiRTTI *	NiRTTI_bhkSPCollisionObject = (NiRTTI *)0x030C94D0;
const NiRTTI *	NiRTTI_bhkMouseSpringAction = (NiRTTI *)0x030C94E8;
const NiRTTI *	NiRTTI_bhkHingeConstraint = (NiRTTI *)0x030C9500;
const NiRTTI *	NiRTTI_bhkCompressedMeshShape = (NiRTTI *)0x030C9578;
const NiRTTI *	NiRTTI_bhkCompressedMeshShapeData = (NiRTTI *)0x030C9588;
const NiRTTI *	NiRTTI_bhkConvexSweepShape = (NiRTTI *)0x030C95A0;
const NiRTTI *	NiRTTI_bhkConvexTransformShape = (NiRTTI *)0x030C95B8;
const NiRTTI *	NiRTTI_bhkConvexTranslateShape = (NiRTTI *)0x030C95D0;
const NiRTTI *	NiRTTI_bhkConvexVerticesShape = (NiRTTI *)0x030C95E8;
const NiRTTI *	NiRTTI_bhkCylinderShape = (NiRTTI *)0x030C9600;
const NiRTTI *	NiRTTI_bhkMultiSphereShape = (NiRTTI *)0x030C9618;
const NiRTTI *	NiRTTI_bhkPlaneShape = (NiRTTI *)0x030C9630;
const NiRTTI *	NiRTTI_bhkTriangleShape = (NiRTTI *)0x030C9648;
const NiRTTI *	NiRTTI_bhkMoppBvTreeShape = (NiRTTI *)0x030C9660;
const NiRTTI *	NiRTTI_bhkTransformShape = (NiRTTI *)0x030C9678;
const NiRTTI *	NiRTTI_bhkListShape = (NiRTTI *)0x030C9690;
const NiRTTI *	NiRTTI_bhkBallAndSocketConstraint = (NiRTTI *)0x030C96A8;
const NiRTTI *	NiRTTI_bhkBallSocketConstraintChain = (NiRTTI *)0x030C96C0;
const NiRTTI *	NiRTTI_bhkGroupConstraint = (NiRTTI *)0x030C96D8;
const NiRTTI *	NiRTTI_bhkHingeLimitsConstraint = (NiRTTI *)0x030C96F0;
const NiRTTI *	NiRTTI_bhkFixedConstraint = (NiRTTI *)0x030C9708;
const NiRTTI *	NiRTTI_bhkRagdollConstraint = (NiRTTI *)0x030C9720;
const NiRTTI *	NiRTTI_bhkRagdollLimitsConstraint = (NiRTTI *)0x030C9738;
const NiRTTI *	NiRTTI_bhkStiffSpringConstraint = (NiRTTI *)0x030C9750;
const NiRTTI *	NiRTTI_bhkWheelConstraint = (NiRTTI *)0x030C9768;
const NiRTTI *	NiRTTI_bhkBreakableConstraint = (NiRTTI *)0x030C9780;
const NiRTTI *	NiRTTI_bhkAngularDashpotAction = (NiRTTI *)0x030C9798;
const NiRTTI *	NiRTTI_bhkDashpotAction = (NiRTTI *)0x030C97B0;
const NiRTTI *	NiRTTI_bhkLiquidAction = (NiRTTI *)0x030C97C8;
const NiRTTI *	NiRTTI_bhkMotorAction = (NiRTTI *)0x030C97E8;
const NiRTTI *	NiRTTI_bhkOrientHingedBodyAction = (NiRTTI *)0x030C9800;
const NiRTTI *	NiRTTI_bhkSpringAction = (NiRTTI *)0x030C9818;
const NiRTTI *	NiRTTI_bhkBlendController = (NiRTTI *)0x030C9828;
const NiRTTI *	NiRTTI_bhkExtraData = (NiRTTI *)0x030C9838;
const NiRTTI *	NiRTTI_bhkPoseArray = (NiRTTI *)0x030C9848;
const NiRTTI *	NiRTTI_bhkGenericConstraint = (NiRTTI *)0x030C9868;
const NiRTTI *	NiRTTI_bhkCharControllerShape = (NiRTTI *)0x030C9878;
const NiRTTI *	NiRTTI_bhkCollisionBox = (NiRTTI *)0x030C9890;
const NiRTTI *	NiRTTI_bhkShapeCollection = (NiRTTI *)0x030C98A8;
const NiRTTI *	NiRTTI_bhkPositionConstraintMotor = (NiRTTI *)0x030C9910;
const NiRTTI *	NiRTTI_bhkVelocityConstraintMotor = (NiRTTI *)0x030C9920;
const NiRTTI *	NiRTTI_bhkSpringDamperConstraintMotor = (NiRTTI *)0x030C9930;
const NiRTTI *	NiRTTI_bhkCharacterProxy = (NiRTTI *)0x030CA6E8;
const NiRTTI *	NiRTTI_bhkCharacterRigidBody = (NiRTTI *)0x030CA700;
const NiRTTI *	NiRTTI_bhkHeightFieldShape = (NiRTTI *)0x030CBA08;
const NiRTTI *	NiRTTI_bhkConstraintChain = (NiRTTI *)0x030CBA20;
const NiRTTI *	NiRTTI_bhkBinaryAction = (NiRTTI *)0x030CBA38;
const NiRTTI *	NiRTTI_bhkPointToPathConstraint = (NiRTTI *)0x030CBA70;
const NiRTTI *	NiRTTI_DebugTextExtraData = (NiRTTI *)0x030CD270;
const NiRTTI *	NiRTTI_BSFadeNode = (NiRTTI *)0x0326B1E8;
const NiRTTI *	NiRTTI_BSShaderProperty = (NiRTTI *)0x0326B218;
const NiRTTI *	NiRTTI_BSLeafAnimNode = (NiRTTI *)0x0326B228;
const NiRTTI *	NiRTTI_BSTreeNode = (NiRTTI *)0x0326B238;
const NiRTTI *	NiRTTI_ShadowSceneNode = (NiRTTI *)0x0326B660;
const NiRTTI *	NiRTTI_BSLightingShaderProperty = (NiRTTI *)0x0326BF30;
const NiRTTI *	NiRTTI_BSGrassShaderProperty = (NiRTTI *)0x0326BF68;
const NiRTTI *	NiRTTI_BSShaderAccumulator = (NiRTTI *)0x0326C180;
const NiRTTI *	NiRTTI_BSEffectShaderProperty = (NiRTTI *)0x0326C320;
const NiRTTI *	NiRTTI_BSWaterShaderProperty = (NiRTTI *)0x032CD148;
const NiRTTI *	NiRTTI_BSBloodSplatterShaderProperty = (NiRTTI *)0x032CD158;
const NiRTTI *	NiRTTI_BSParticleShaderProperty = (NiRTTI *)0x032CD548;
const NiRTTI *	NiRTTI_BSTextureSet = (NiRTTI *)0x032CD898;
const NiRTTI *	NiRTTI_BSShaderTextureSet = (NiRTTI *)0x032CD8A8;
const NiRTTI *	NiRTTI_BSSkyShaderProperty = (NiRTTI *)0x032CDBA8;
const NiRTTI *	NiRTTI_BSFadeNodeCuller = (NiRTTI *)0x0331DC30;
const NiRTTI *	NiRTTI_BSDistantTreeShaderProperty = (NiRTTI *)0x0331DC60;
const NiRTTI *	NiRTTI_BSCubeMapCamera = (NiRTTI *)0x0331DE40;
const NiRTTI *	NiRTTI_BSFogProperty = (NiRTTI *)0x0331DEF8;
const NiRTTI *	NiRTTI_BSClearZNode = (NiRTTI *)0x0352FFB8;
const NiRTTI *	NiRTTI_NiCollisionObject = (NiRTTI *)0x035300D8;
const NiRTTI *	NiRTTI_BSOrderedNode = (NiRTTI *)0x035300E8;
const NiRTTI *	NiRTTI_BSLines = (NiRTTI *)0x035300F8;
const NiRTTI *	NiRTTI_BSDynamicLines = (NiRTTI *)0x03530108;
const NiRTTI *	NiRTTI_BSMultiIndexTriShape = (NiRTTI *)0x03530128;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyFloatController = (NiRTTI *)0x035301D0;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyUShortController = (NiRTTI *)0x035301E8;
const NiRTTI *	NiRTTI_BSLightingShaderPropertyColorController = (NiRTTI *)0x03530200;
const NiRTTI *	NiRTTI_BSEffectShaderPropertyFloatController = (NiRTTI *)0x03530238;
const NiRTTI *	NiRTTI_BSEffectShaderPropertyColorController = (NiRTTI *)0x03530250;
const NiRTTI *	NiRTTI_BSNiAlphaPropertyTestRefController = (NiRTTI *)0x03530260;
const NiRTTI *	NiRTTI_BSPSysSimpleColorModifier = (NiRTTI *)0x03530270;
const NiRTTI *	NiRTTI_BSPSysLODModifier = (NiRTTI *)0x03530280;
const NiRTTI *	NiRTTI_BSParabolicCullingProcess = (NiRTTI *)0x03530708;
const NiRTTI *	NiRTTI_BSMeshLODTriShape = (NiRTTI *)0x03530718;
const NiRTTI *	NiRTTI_BSLODMultiIndexTriShape = (NiRTTI *)0x03530728;
const NiRTTI *	NiRTTI_BSSubIndexLandTriShape = (NiRTTI *)0x03530740;
